package costo.kml2java.monitor;

import costo.kml2java.framework.ExecutableComponent;
import costo.kml2java.monitor.gui.basecomponents.SimpleComponentView;

public class TestExecutableComponent {

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		// ExecutableComponent comp= new SimpleApplication();
		// comp.setAutorunEnabled(false);
		// monitorApplication(comp);

	}

	/**
	 * @param comp
	 */
	public static void monitorApplication(ExecutableComponent comp) {
		comp.setPaused(true);
		comp.init();

		createCompViews(comp);
	}

	private static void createCompViews(ExecutableComponent comp) {

		SimpleComponentView test = new SimpleComponentView(comp);
		if (comp.isComposite()) {
			for (ExecutableComponent subcomp : comp.getInnerContext().getInstances().values()) {
				createCompViews(subcomp);
			}
		}
	}

}
