package mylib;

import org.jdom2.Element;
import costo.kml2java.framework.IProvidedService;

public final class PlatoonTestlibMap {
	public static Element currentNode = null;
	
	public PlatoonTestlibMap() {}
	
	public static void assertT(boolean verdict, IProvidedService p) {
		System.out.println(">>TEST<< " + p.getLongName() + " verdict is " + verdict+"\n");
		//Save the verdict in the XML file
	    currentNode.getChild("verdict").setText(verdict+""); 
	}
	
	public static Object getData(String variable){
		if(currentNode == null){
			System.out.println("Node is Null");
			return null;
		}
		
		try{
			return currentNode.getChildText(variable);
		}catch(Exception e){
			System.out.println("value for "+variable+" is null");
			e.printStackTrace();
		}
		
		return null;
	}
	
	public static Object getData(String variable, String type){
	if(currentNode == null){
			System.out.println("Node is Null");
			return null;
		}
		String var = currentNode.getChildText(variable);
		if(var != null){
			if((type).equals("Integer")){
				return Integer.parseInt(var);
			}
			if((type).equals("Float")){
				return Float.parseFloat(var);
			}
			if((type).equals("Long")){
				return Long.parseLong(var);
			}
			if((type).equals("Double")){
				return Double.parseDouble(var);
			}
			if((type).equals("Boolean")){
				return Boolean.parseBoolean(var);
			}
			if((type).equals("String")){
				return var.toString();
			}
		}
		return null;
	}
}